import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class HelpList extends List implements CommandListener
{
    Calculator calculator;
   /*
   // moved to Locale.java
   //
    static final String[] help = {
        "e1,e2: sequence",
        "x=1: assignment",
        "f(x)=x*x: function",
        "c?x:y: choice",
        "x>y: greater than",
        "x<y: less than",
        "1<x<5: between",
        "x+y: addition",
        "x-y: subtraction",
        "x*y: multiplication",
        "x/y: division",
        "x^y: power",
        "[x]: integer part",
        "{x}: fraction part",
        "|x|: absolute value",
        "(e): parentheses",
        "sin(x): sine",
        "cos(x): cosine",
        "tan(x): tangent",
        "asin(x): arcsine",
        "acos(x): arccosine",
        "atan(x): arctangent",
        "exp(x): exponent",
        "log(x): oridinal logarithm",
        "ln(x): natural logarithm",
        "ceil(x): ceil",
        "floor(x): floor",
        "sqr(x): square root",
        "plot(from,till,func): draw graph"
    };
    */
    static final String[] insert = {
        ",",
        "=",
        "()=",
        "?:",
        ">",
        "<",
        "<<",
        "+",
        "-",
        "*",
        "/",
        "^",
        "[]",
        "{}",
        "||",
        "()",
        "sin()",
        "cos()",
        "tan()",
        "asin()",
        "acos()",
        "atan()",
        "exp()",
        "log()",
        "ln()",
        "ceil()",
        "floor()",
        "sqr()",
        "plot(,,)",
        "plot(,,,)",
        "plot{,,,,}"
    };

    HelpList(Calculator calculator)
    {
        super(Locale.RES_STATEMENTS, IMPLICIT, Locale.help, null);
        this.calculator = calculator;
        setCommandListener(this);
        addCommand(Calculator.BACK_CMD);
        addCommand(Calculator.INS_CMD);
        Display.getDisplay(calculator).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d)
    {
        if (c == Calculator.INS_CMD) {
            int i = getSelectedIndex();
            if (i >= 0) {
                calculator.insertText(insert[i]);
            }
        }
        Display.getDisplay(calculator).setCurrent(calculator.mainMenu);
    }
}

