import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.util.Vector;

public class StatementList extends List implements CommandListener
{
    Calculator calculator;

    static Image states[];

    static {
        states = new Image[3];
        try {
            states[Calculator.Statement.UNKNOWN] = Image.createImage("/unknown.png");
            states[Calculator.Statement.COMPILED] = Image.createImage("/compiled.png");
            states[Calculator.Statement.ERROR] = Image.createImage("/error.png");
        } catch (java.io.IOException err) {}
    }

    StatementList(Calculator calculator)
    {
        super(Locale.RES_STATEMENTS, IMPLICIT);
        this.calculator = calculator;
        Vector stmts = calculator.statements;
        for (int i = 0, n = stmts.size(); i < n; i++) {
            Calculator.Statement stmt = (Calculator.Statement)stmts.elementAt(i);
            append(stmt.text, states[stmt.state]);
        }
        setCommandListener(this);
        addCommand(Calculator.BACK_CMD);
        addCommand(Calculator.EDIT_CMD);
        addCommand(Calculator.DELETE_CMD);
        addCommand(Calculator.NEW_CMD);
        addCommand(Calculator.INS_CMD);
        Display.getDisplay(calculator).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d)
    {
        if (c == Calculator.BACK_CMD) {
            Display.getDisplay(calculator).setCurrent(calculator.mainMenu);
        } else {
            int i = getSelectedIndex();
            if (i >= 0) {
                if (c == Calculator.DELETE_CMD) {
                    if (calculator.statements.size() == 1) {
                        set(i, "", null);
                    } else {
                        delete(i);
                    }
                    calculator.removeStatement(i);
                } else if (c == Calculator.NEW_CMD) {
                    calculator.newStatement();
                    Display.getDisplay(calculator).setCurrent(calculator.mainMenu);
                } else if (c == Calculator.INS_CMD) {
                    String text = ((Calculator.Statement)calculator.statements.elementAt(i)).text;
                    int j = text.indexOf('(');
                    if (j < 0 || text.indexOf('=') < j) {
                        calculator.showAlert(AlertType.ERROR, Locale.RES_ERROR, Locale.RES_NOT_FUNCTION);
                    } else {
                        StringBuffer profile = new StringBuffer();
                        profile.append('(');
                        if (text.charAt(j) != '=') {
                            if (text.charAt(j) == ',') {
                                profile.append(',');
                            }
                        }
                        profile.append(')');
                        calculator.insertText(text.substring(0, j) + profile);
                        Display.getDisplay(calculator).setCurrent(calculator.mainMenu);
                    }
                } else {
                    calculator.editStatement(i);
                    Display.getDisplay(calculator).setCurrent(calculator.mainMenu);
                }
            }
        }
    }
}

